/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: TWI_Master.c
* ߲		: IAR EWAAVR 2.28a/3.10c
* 			: $Revision: 1.13 $
* t			: $Date: 24. mai 2004 11:31:20 $
* XV		: $Author: ltwa $
*
* xҰ		: avr@atmel.com
*
* x޲	: gp\TWIS޲
*				  (ATmega16pɏĂ܂B)
*
* pLq		: AVR315 - TWI呕u
*
* 			: AVRTWIɑ΂鎎ײނłB
*				  ͊荞݋쓮łBSĂ̋@\͊֐Ƃ̏nʂ
*				  Đ䂳܂Bײގgp@̗main.cB
*
****************************************************************************/

#include "ioavr.h"
#include "inavr.h"
#include "TWI_Master.h"

static unsigned char TWI_buf[ TWI_BUFFER_SIZE ];	// TWIMɏՕ
static unsigned char TWI_msgSize;					// M޲Đ
static unsigned char TWI_state = TWI_NO_STATE;		// TWI޲(TWI_NO_STATE)

union TWI_statusReg TWI_statusReg = {0};			// ׸(TWI_statusRegTWI_Master.hŒ`Ă܂B)

/****************************************************************************
TWI呕ȕҋ@Ԃɐݒ肷ɂ͂̊֐ĂłBTWI
Ɏ剞pŊ荞݂邱ƂYȂłB
****************************************************************************/
void TWI_Master_Initialize(void)
{
	TWBR = TWI_TWBR+1;							// ޯđxݒ(ͯ ̧قŒ`)

	TWDR = 0xFF;								// ްl(SDAJɂ܂B)
	TWCR = (1<<TWEN)|							// TWI
		   (0<<TWIE)|(0<<TWINT)|				// TWI荞݋֎~
		   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// TWI޽J(NACK)
		   (0<<TWWC);							//
}

/****************************************************************************
TWI荞ݏٰ݂]Z𒲂ׂɂ͂̊֐ĂłB
****************************************************************************/
unsigned char TWI_Transceiver_Busy( void )
{
	return ( TWCR & (1<<TWIE) );				// TWI荞݂ȂAMZłB
}

/****************************************************************************
Ȍԏ擾ɂ͂̊֐ĂłB֐TWI荞ݏ
ٰ݂O܂ŎsT܂(ҋ@)Bُ킪ꍇA֐
TWIԕԂ܂B
****************************************************************************/
unsigned char TWI_Get_State_Info( void )
{
	while ( TWI_Transceiver_Busy() );			// TWI]܂őҋ@
	return ( TWI_state );						// TWIԕƋɕA
}

/****************************************************************************
\ߗpӂꂽүނ𑗂ɂ͂̊֐ĂłB擪޲Ă͏]uڽ
Ɠǂ/(R/W)ޯĂ܂܂Ȃ΂Ȃ܂B޲Ăׂ͑ްA܂
͏]uǂނׂްɑ΂̈ʒu܂݂܂B܂Aڽ ޲Ă܂߂ĉ
޲Ă󂳂ׂ܂݂܂B֐TWI荞ݏٰ݂OA
Ď̑Ė߂܂ŎsT܂(ҋ@)B
****************************************************************************/
void TWI_Start_Transceiver_With_Data( unsigned char *msg, unsigned char msgSize )
{
	unsigned char temp;

	while ( TWI_Transceiver_Busy() );				// TWI܂őҋ@

	TWI_msgSize = msgSize;							// M޲Đ(ۑ)
	TWI_buf[0]  = msg[0];							// ]uڽ+R/WޯĂg̊ɏՕ֕
	if (!( msg[0] & (TRUE<<TWI_READ_BIT) ))			// 呕uݓŁA
	{
		for ( temp = 1; temp < msgSize; temp++ )	// Mްg̊ɏՕ֕
			TWI_buf[ temp ] = msg[ temp ];
	}
	TWI_statusReg.all = 0;							// S׸ޏ((0))
	TWI_state         = TWI_NO_STATE ;				// TWIԂȂԂɐݒ
	TWCR = (1<<TWEN)|								// TWI
		   (1<<TWIE)|(1<<TWINT)|					// TWI荞݋,TWI荞ݗv׸މ(0)
		   (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|			// JnoJn
		   (0<<TWWC);								//
}

/****************************************************************************
ŏIүނđɂ͂̊֐ĂłBײނ͒OɑMɏ
ɒuꂽްĎgp܂B֐TWI荞ݏٰ݂OA
Ď̑Ė߂܂ŎsT܂(ҋ@)B
****************************************************************************/
void TWI_Start_Transceiver( void )
{
	while ( TWI_Transceiver_Busy() );			// TWI܂őҋ@
	TWI_statusReg.all = 0;						// S׸ޏ((0))
	TWI_state         = TWI_NO_STATE ;			// TWIԂȂԂɐݒ
	TWCR = (1<<TWEN)|							// TWI
		   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
		   (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|		// JnoJn
		   (0<<TWWC);							//
}

/****************************************************************************
TWIMɏՕvްǂݏoɂ͂̊֐ĂłB
ƁAްv]u֑邽߁ATWI_Start_Transceiver_With_Data֐
łBĂ炪ް擾邽߂ɂ̊֐𑖂点
ĂBްuꏊւ߲(ڽ̈܂߂)v޲Đ֐
ĂяoɊ܂߂ĂB֐ްǂݏoĖ߂OɁATWI荞ݏٰ
O܂ŎsT܂(ҋ@)Bُ킪ꍇA֐
TWIԕԂ܂B
****************************************************************************/
unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
{
	unsigned char i;

	while ( TWI_Transceiver_Busy() );			// TWI܂őҋ@

	if( TWI_statusReg.lastTransOK )				// ŏI]ŁA
	{
		for ( i=0; i<msgSize; i++ )				// Mޯ̧牞pޯ̧֓e
		{
			msg[ i ] = TWI_buf[ i ];
		}
	}
	return( TWI_statusReg.lastTransOK );		// L/׸ނƋɕA
}

// ********** 荞ݏٰ ********** //
/****************************************************************************
̊֐͊荞ݏٰ(ISR)ŁATWIۂNɕKNTWI荞
ݎɎIɌĂ΂܂B̊֐͎剞p璼ڌĂ΂ׂł͂܂B
****************************************************************************/
#pragma vector=TWI_vect
__interrupt void TWI_ISR(void)
{
	static unsigned char TWI_bufPtr;

	switch (TWSR)
	{
		case TWI_START:						// Jno
		case TWI_REP_START:					// đJno
			TWI_bufPtr = 0;					// MɏՕʒuwq
		case TWI_MTX_ADR_ACK:				// SLA+WM,ACKM
		case TWI_MTX_DATA_ACK:				// ް ޲đM,ACKM
			if (TWI_bufPtr < TWI_msgSize)				// ɏՕc޲ėLŁA
			{
				TWDR = TWI_buf[TWI_bufPtr++];				// Ή޲ĂTWDRɕ,ʒuwqis
				TWCR = (1<<TWEN)|							// TWI
					   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
					   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// NACKw
					   (0<<TWWC);							//  
			}else										// ɍŏI޲čς݂ŁA
			{
				TWI_statusReg.lastTransOK = TRUE;			// ]׸ސݒ(1)
				TWCR = (1<<TWEN)|							// TWI
					   (0<<TWIE)|(1<<TWINT)|				// TWI荞݋֎~,TWI荞ݗv׸މ(0)
					   (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|		// ~oJn
					   (0<<TWWC);							//
			}
			break;
		case TWI_MRX_DATA_ACK:				// ް ޲ĎM,ACKԓ
			TWI_buf[TWI_bufPtr++] = TWDR;				// MްlTWIMɏՕɊi[
		case TWI_MRX_ADR_ACK:				// SLA+RM,ACKM
			if (TWI_bufPtr < (TWI_msgSize-1) )			// ŏI޲ĈȑOŁA
			{
				TWCR = (1<<TWEN)|							// TWI
					   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
					   (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// MACKw
					   (0<<TWWC);							//
			}else										// ŏI޲ĂŁA
			{
				TWCR = (1<<TWEN)|							// TWI
					   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
					   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// MNACKw
					   (0<<TWWC);							//
			}
			break;
		case TWI_MRX_DATA_NACK:				// ް ޲ĎM,NACKԓ
			TWI_buf[TWI_bufPtr] = TWDR;					// MްlTWIMɏՕɊi[
			TWI_statusReg.lastTransOK = TRUE;			// ]׸ސݒ(1)
			TWCR = (1<<TWEN)|							// TWI
				   (0<<TWIE)|(1<<TWINT)|				// TWI荞݋֎~,TWI荞ݗv׸މ(0)
				   (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|		// ~oJn
				   (0<<TWWC);							//
			break;
		case TWI_ARB_LOST:					// r(s)
			TWCR = (1<<TWEN)|							// TWI
				   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋֎~,TWI荞ݗv׸މ(0)
				   (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|		// (đ)JnoJn
				   (0<<TWWC);							//
			break;
		case TWI_MTX_ADR_NACK:				// SLA+WM,NACKM
		case TWI_MRX_ADR_NACK:				// SLA+RM,NACKM
		case TWI_MTX_DATA_NACK:				// ް ޲đM,NACKM
//		case TWI_NO_STATE					// p\Ȋ֘A󋵏Ȃ
		case TWI_BUS_ERROR:					// s@ȊJn܂͒~̂߂޽ُ
		default:
			TWI_state = TWSR;							// ُƂTWIԕݒ
			TWCR = (1<<TWEN)|							// TWI
				   (0<<TWIE)|(0<<TWINT)|				// TWI荞݋֎~
				   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// TWI޽J(NACK)
				   (0<<TWWC);							// (TWIؾ)
	}
}
